---
categories: web
title: Howto NodeJS
...

* Documentation : <https://nodejs.org/dist/latest-v6.x/docs/api/>
* Rôle Ansible : <https://forge.evolix.org/projects/ansible-roles/repository/show/nodejs>

[NodeJS](https://nodejs.org/) est une implémentation cote serveur du langage Javascript.

## Installation

Nodejs est disponible en version 4.x sur Debian Stretch. Mais son cycle de maintenance par développeurs se termine en Avril 2018.
Sur Debian Jessie, c'est la version 0.10.X qui est présente mais elle est déprécié par l'upstream…

Pour installer une version plus récente (ex: 8.X LTS), on peut utiliser les dépôts de nodesource. Ainsi, pour Debian Stretch :

~~~
# echo "deb http://deb.nodesource.com/node_8.x stretch main" > /etc/apt/sources.list.d/nodesource.list
# wget https://deb.nodesource.com/gpgkey/nodesource.gpg.key -O -|apt-key add -
# apt update
# apt install nodejs

$ nodejs -v
v8.9.4
~~~

Il est également possible d'installer la version 9 en remplaçant la fin de l'URL du dépôt par `node_9.x`. Mais la branche 9.x ne n'aura pas de support sur le long terme.

## Utilisation de module NPM

On peut ensuite installer des packages npm en tant qu'utilisateur :

~~~
$ npm version
{ npm: '5.6.0',
  ares: '1.10.1-DEV',
  cldr: '31.0.1',
  http_parser: '2.7.0',
  icu: '59.1',
  modules: '57',
  nghttp2: '1.25.0',
  node: '8.9.4',
  openssl: '1.0.2n',
  tz: '2017b',
  unicode: '9.0',
  uv: '1.15.0',
  v8: '6.1.534.50',
  zlib: '1.2.11' }

$ npm install ping
/home/foo
└─┬ ping@0.2.2
  ├── q@1.5.1
  └── underscore@1.8.3

$ npm list
/home/foo
└─┬ ping@0.2.2
  ├── q@1.5.1
  └── underscore@1.8.3
~~~


Certains modules peuvent aussi être installés de manière globale. 
Et ainsi rendre la commande disponible via /usr/bin/<nom_module> et les bibliothèques dans */usr/lib/node_modules*

~~~
npm install -g npm
chown -R root: /usr/lib/node_modules/npm
chmod -R 755 /usr/lib/node_modules/npm
~~~
